////////////////////////////////////////////////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////s           www.testbench.in           s////
////s                                      s////
////s             UVM Tutorial             s////
////s           gopi@testbenh.in           s////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////////////////////////////////////////////////

class demo_pre_body_post_body extends uvm_sequence #(instruction);

  instruction req;
 
  function new(string name="demo_pre_body_post_body");
    super.new(name);
  endfunction
  
  `uvm_sequence_utils(demo_pre_body_post_body, instruction_sequencer)    

  virtual task pre_body();
       uvm_report_info(get_full_name()," pre_body() callback ",UVM_LOW);
  endtask

  virtual task post_body();
       uvm_report_info(get_full_name()," post_body() callback ",UVM_LOW);
  endtask

  virtual task body();
     uvm_report_info(get_full_name(),"body() method: Before uvm_do macro ",UVM_LOW);
     `uvm_do(req);
     uvm_report_info(get_full_name(),"body() method: After uvm_do macro ",UVM_LOW);
  endtask
  
endclass 

